<?php
/**
 * ----------------------------------------------------------
 * Copyright (c) 2005  KLIK! Klein Informatik  
 *                     www.klik-info.ch rklein@klik-info.ch
 * ----------------------------------------------------------
 *
 * KLIK! Mini-Shop
 *
 * Dieses Skript darf nicht in Projekten verwendet werden, die
 * faschistisches, rassistisches, sexistisches oder 
 * fanatisch-religioeses Gedankengut propagieren.
 *
 * @author      Roger Klein
 * @copyright   Frei einsetzbar, solange obige Vorgabe erfuellt ist
 *              und alle (c) Kommentar-Zeilen im Code bleiben
 * @version     1.0 | 2005-10-12
 */

// Logout
if (isset($_GET['logout']))
{
    session_start();
    session_destroy();
}

// Benoetigte Dateien einbinden
require_once '../inc/db_login.php';
require_once 'login.php';
require_once '../inc/aufklapp_oop.php';
require_once '../inc/form_fus.php';

// Deklaration u. Initialisierung Variablen 
// u. Konstanten fuer die Bilder-Verarbeitung
define('PFAD', '../img/');  // relativer Pfad
define('MAX_SIZE', 102400); // in Bytes
$max_thumbnail_breite  = 102;
$max_thumbnail_hoehe   = 80;

// Deklaration u. Initialisierung Variablen 
// u. Konstanten fuer die Verarbeitung der
// Formular-Daten
$meldung = '';
$label_1 = 'Neuer Artikel';
$label_2 = 'Artikel erfassen';
// Falls weder im $_POST- noch im $_GET-Array
// ein Eintrag 'a_id' vorhanden ist, wird der Variable
// $a_id eine -1 zugewiesen (= neuen Artikel erfassen)
$a_id    = isset($_REQUEST['a_id']) ? $_REQUEST['a_id'] : -1;
$k_id    = isset($_REQUEST['k_id']) ? $_REQUEST['k_id'] : '';
// alle zu verarbeitenden Daten werden im Array $data
// gespeichert
$data    = array('artikel'        => '',
                'k_id'            => $k_id,
                'kurzbeschrieb'   => '',
                'detail'          => '',
                'preis'           => '',
                'aktiv'           => '0',
                'bild'            => ''
                );

// Das Formular wurde verschickt => Verarbeitung
// der Formulardaten             
if (isset($_POST['a_id'])) 
{
    // Filtern der Formular-Daten
    $data = array_map('filter_data',$_POST);
    
    $a_id = $_POST['a_id'];
    
    $meldung = '<font color="red">Der Datenbank-Eintrag hat nicht geklappt</font>';

    // Eingabe-Check:
    // Fehlerhafte oder fehlende Eingaben
    if ($data['artikel'] == '' || $data['preis'] == '')
    {
        $meldung = '<font color="red">Bitte alle *-Felder ausf&uuml;llen</font>';
    }
    // Eingaben okay => Verarbeitung
    else
    {
        // Einen neuen Artikel einfuegen
        if ($a_id == -1) 
        {
            // Alle einzufuegenden Daten sind zu "quoten"
            // => so lassen sich Konflikte mit ' oder "
            // vermeiden und allfaellige SQL-Attacken
            // entschaerfen
            $abfrage= 'INSERT INTO ' . $tbl_prefix. 'artikel
                       (artikel,k_id,kurzbeschrieb,detail,preis,aktiv) 
                       VALUES ('
                       . sql_quote($data['artikel']) . ','
                       . sql_quote($data['k_id']) . ','
                       . sql_quote($data['kurzbeschrieb']) . ',' 
                       . sql_quote($data['detail']) . ','
                       . sql_quote($data['preis']) . ','
                       . sql_quote($data['aktiv']) . ')';
            if (FALSE != mysql_query($abfrage))
            {
                // Die ID des gerade eingefuegten Datensatze
                // wird der Variable $a_id zugewiesen
                $a_id = mysql_insert_id();
                $meldung = '<font color="green">Der neue Artikel wurde erfasst</font>';
            }
        }
        // einen bestehenden Artikel aktualisieren
        else 
        {
            $abfrage= 'UPDATE ' . $tbl_prefix . 'artikel
                       SET 
                        artikel       =' . sql_quote($data['artikel']) . ', 
                        k_id          =' . sql_quote($data['k_id']) . ', 
                        kurzbeschrieb =' . sql_quote($data['kurzbeschrieb']). ',
                        detail        =' . sql_quote($data['detail']).',
                        preis         =' . sql_quote($data['preis']).',
                        aktiv         =' . sql_quote($data['aktiv']).'
                       WHERE a_id=' . $a_id;
            if (FALSE != mysql_query($abfrage))
            {
                $meldung = '<font color="green">Die &Auml;nderungen wurden gespeichert</font>';
            }    
        }
        // Die Seiten-Ueberschrift und der Submit-Knopf
        // erhalten neue Text-Eintraege
        $label_1 = 'Artikel bearbeiten';
        $label_2 = 'Eingaben speichern';
        
        // Wurde eine Bilddatei mit hochgeladen?       
        if ($a_id != -1 && is_uploaded_file($_FILES['datei']['tmp_name'])) 
        {
            include 'upload.php';
            // Die Funktion upload() erledigt das Hochladen
            // Falls sie einen Leerstring '' zuruck liefert,
            // hat das Hochladen geklappt
            $upload_meldung = upload($_FILES['datei'], $a_id);
            // Bild-Upload hat geklappt => Thumbnail erzeugen
            // und Datebank-Eintrag aktualisieren
            if ($upload_meldung == '')
            {
                require_once 'thumbnail.php';
                $tn =& new Thumbnail($max_thumbnail_breite,
                                     $max_thumbnail_hoehe, 
                                     true, false);
                // Die Extension der hoch geladenen Datei wird
                // ermittelt
                $extension = substr($_FILES['datei']['name'], -3);
                // Das grosse Bild erhaelt einen Namen nach 
                // folgendem Muster: 'g_foto' . $a_id . $extension
                // Beispiel: 'g_foto23.jpg'
                $tn->loadFile(PFAD . 'g_foto' . $a_id . '.' 
                              . $extension);
                // Das kleine Bild erhaelt einen Namen nach 
                // folgendem Muster: 'foto' . $a_id . $extension
                // Beispiel: 'foto23.jpg'
                $tn->buildThumb(PFAD . 'foto' . $a_id . '.' 
                                . $extension);
                                
                // Aktualisieren des Datenbank-Eintrags:
                // Es wird nur die Extension ins Feld "bild"
                // gespeichert!                
                $abfrage= 'UPDATE ' . $tbl_prefix . 'artikel
                           SET bild = "' . $extension . '"
                           WHERE a_id = ' . $a_id;
                if (FALSE != mysql_query($abfrage))
                {
                    $meldung .= ' <font color="green">Das Foto wurde auf den Server geladen</font>';
                }    
            }
            else
            {
                $meldung .= ' <font color="red">Das Foto wurde nicht auf den '
                            . 'Server geladen (' . $upload_meldung . ')</font>';
            }
        }
        
    }
}

// Die Daten fuer die Anzeige im Formular werden aus
// der Datenbank geholt (falls es sich nicht ums Neuerfassen
// eines Artikels handelt
if ($a_id != -1)
{
    $abfrage  = 'SELECT artikel,k_id,kurzbeschrieb,detail,preis,aktiv,bild
                 FROM ' . $tbl_prefix . 'artikel 
                 WHERE a_id=' . $a_id;
    $ergebnis = mysql_query($abfrage);
    $data     = mysql_fetch_array($ergebnis, MYSQL_ASSOC);
    
    $label_1 = 'Artikel bearbeiten';
    $label_2 = 'Eingaben speichern';
}

// "Entschaerfen" allfaelliger HTML-Tags
$data = array_map('htmlspecialchars', $data);

// Aufklapp-Menu mit den Kategorien vorbereiten
$select_name = 'k_id';
$abfrage     = 'SELECT k_id, kat
                FROM ' . $tbl_prefix . 'kategorien
                ORDER BY sortierung';
$ergebnis    = mysql_query($abfrage);
$arr_items   = array();
while ($datensatz = mysql_fetch_array($ergebnis, MYSQL_ASSOC)) 
{
    $arr_items[$datensatz['k_id']] = $datensatz['kat'];
}
$kat_menu = & new AufklappMenu($k_id, $arr_items, $select_name, 0);
?>
<html>
    <head>
        <meta http-equiv="content-type" content="text/html;charset=ISO-8859-1">
        <meta name="robot" content="noindex, nofollow">
        <title>KLIK! Mini-Shop - Administration</title>
        <link rel="StyleSheet" href="../korb.css" type="text/css">
    </head>

<body>
<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="POST" enctype="multipart/form-data">
<div id="titel">
<h3>KLIK! Mini-Shop Administration: <?php echo $label_1; ?></h3>
</div>
<div id="meldung">
<?php
if ($meldung != '')
{
    echo $meldung;
}
?>
</div>
</div>

<div id="formular">
<table>
    <tr>
        <td align="left" valign="middle">Artikel: *</td>
        <td align="left" valign="middle"><input type="text" name="artikel" size="30" maxlength="255" value="<?php echo $data['artikel']; ?>"></td>
    </tr>
    <tr>
        <td align="left" valign="middle">Kategorie: *</td>
        <td align="left" valign="middle"><?php echo $kat_menu->erzeugeMenu(); ?></td>
    </tr>
    <tr>
        <td align="left" valign="middle">Kurzbeschrieb:</td>
        <td align="left" valign="middle"><textarea name="kurzbeschrieb" style="width:300px;height:100px"><?php echo $data['kurzbeschrieb']; ?></textarea></td>
    </tr>
    <tr>
        <td align="left" valign="middle">Details:</td>
        <td align="left" valign="middle"><textarea name="detail" style="width:300px;height:120px"><?php echo $data['detail']; ?></textarea></td>
    </tr>
    <tr>
        <td align="left" valign="middle">Preis: *</td>
        <td align="left" valign="middle"><input type="text" name="preis" size="30" maxlength="255" value="<?php echo $data['preis']; ?>"></td>
    </tr>
    <tr>
        <td align="left" valign="middle" width="90">Aktiv: </td>
        <td align="left">
        <input type="radio" name="aktiv" value="1"<?php if ($data['aktiv'] == '1'){ echo ' checked="checked"';} ?>/>Ja
        <input type="radio" name="aktiv" value="0"<?php if ($data['aktiv'] == '0'){ echo ' checked="checked"';} ?>/>Nein
        </td>
    </tr>
    <tr>
        <td align="left" valign="middle">Bild:</td>
        <td align="left" valign="middle"><input type='file' name='datei'>&nbsp;&nbsp;&nbsp;
        <input type='hidden' name='MAX_FILE_SIZE' value='<?php echo MAX_SIZE; ?>'></td>
    </tr>
    <tr>
        <td align="left"><input type="hidden" name="a_id" value="<?php echo $a_id; ?>"></td>
        <td><br/><input type="submit" name="submit" value="<?php echo $label_2; ?>"></td>
    </tr>
</table>
</form>
<br/><br/><a href="index.php?zufall=<?php echo time().'&k_id='.$k_id; ?>">Zur Artikel-Liste</a>
</div>
<div id="bild" style="position:absolute;margin-left:440px;margin-top:70px">
<?php
// Falls fuer den aktuellen Artikel ein Bild vorhanden
// ist, wird dieses angezeigt (Thumbnail)
if ($data['bild'] != '' && file_exists(PFAD . 'foto' . $a_id . '.' 
                                       . $data['bild']))
{
    echo '<img src="' . PFAD . 'foto' . $a_id . '.' . $data['bild'] . '" />';
}
?>
</div>
<?php
mysql_free_result($ergebnis);
mysql_close($verbindung);
?>
</body>
</html>